define(function( require ){

	const jQuery        = require( 'jquery' );
	const taffy_loader  = require( 'TAFFY' );
	const Mustache      = require( 'mustache' );

	return function( s ){



		/*
			N O D E S
		 */
		let target_node    = {};
		let template_node  = {};
		let button_node    = {};

		/*
			P R I V A T E   V A R S
		 */
		let template_string = "";
		let posts           = TAFFY();

		//let limit = 6;
		let offset        = 0;
		let show_count    = ( s.show_count ) ? s.show_count : 9;

		// AJAX PARAMS
		let ajax_url_base      = "";
		let ajax_url_parameter = "";

		/*
			I N I T
		 */

		init( s );

		/*
			E V E N T S
		 */

		window.addEventListener('hashchange', function() {

			ajax_load_news();

		}, false);


		/*
			M E T H O D S
		 */
		 function init( s ){
 			update( s );


			button_node.on( 'click', function( event ){
				event.preventDefault();
				let current_page = location.hash.substr(1);
				current_page     = ( current_page ) ? current_page : 0;
				current_page     = parseInt( current_page );
				new_page         = current_page + 1;
				location.hash    = new_page;
			} )

			ajax_load_news();
 		}

 		function update( s ){
 			target_node        = jQuery( s.target_selector );
 			template_node      = jQuery( s.template_selector  );
			button_node        = jQuery( s.button_selector );
 			template_string    = template_node.html();
			ajax_url_base      = button_node.attr( 'data-ajax-base' );
			ajax_url_parameter = button_node.attr( 'data-ajax-get' );
 		}


		function render_news(){
			let selector = {};
			posts().filter( selector ).start( offset ).each( function (r) {
				target_node.append( Mustache.render( template_string, r ) );
			})
		}

		function ajax_load_news(){
			const page_to_load = location.hash.substr(1);
			const xhr_request  = new XMLHttpRequest();
			xhr_request.open('GET', ajax_url_base + page_to_load + ajax_url_parameter, true);

			console.log( ajax_url_base + page_to_load + ajax_url_parameter );

			xhr_request.onload = function( response_status ) {
				const is_200    = ( this.status === 200 ) ? true : false;

				if( is_200 ){
					const new_posts = JSON.parse( this.responseText );
					add_news_to_post( new_posts );
					render_news();
					update_offset();
				} else {
					console.warn( 'Konnte keinen weiteren Posts laden: ' );
					console.warn( response_status );
					console.warn( this );
				}
			};

			xhr_request.send( null );
		}

		function add_news_to_post( new_posts ){
			posts.insert( new_posts );
		}

		function update_offset(){
			offset = posts().count() + 1;
		}

		return{
			init : init,
		}
	}
})
